//+------------------------------------------------------------------+
//|                                                  CCI_Reversy.mq4 |
//|                               Copyright  Evgeniy Trofimov, 2009 |
//|                                   http://vkontakte.ru/id5374887/ |
//+------------------------------------------------------------------+
/*
       CCI:
:
-    (High, Low, Close)   CCIPeriod
:
-   Close,  CCI     FindCCI.
:
-       High   Low,  ,
    EMPTY_VALUE,      .
*/
#property copyright "Copyright  Evgeniy Trofimov, 2009"
#property link      "http://vkontakte.ru/id5374887/"
extern int  CCIPeriod = 14;
extern double FindCCI = 100.0;
//+------------------------------------------------------------------+
int deinit() {
   if(ObjectFind("MyLine")!=-1) ObjectDelete("MyLine");
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   double Price;
   Price=PriceCCI(FindCCI);
   return(0);
} //start()
//+------------------------------------------------------------------+
double PriceCCI(double LevelCCI, int CurrentCandle=0) {
   //  CCI
   double MovBuffer;
   double Price, SummPrice, Abs, SummAbs;
   double K = 0.015;
   int j;
   for(int i=CCIPeriod-1; i>=0; i--) {
      j=i+CurrentCandle;
      Price = (High[j]+Low[j]+Close[j])/3;
      MovBuffer=iMA(NULL,0,CCIPeriod,0,MODE_SMA,PRICE_TYPICAL,CurrentCandle);
      Abs = MathAbs(Price-MovBuffer);
      if(i>0) {
         SummPrice += Price;
         SummAbs += Abs;
      }
   }//Next i
   double CCI = (Price-MovBuffer)/((SummAbs+Abs)*K/CCIPeriod);
   Comment("CCI("+CCIPeriod+") = "+DoubleToStr(CCI,4)+"\nFindCCI = "+DoubleToStr(LevelCCI,1));
   //    CCI       
   double H = High[CurrentCandle];
   double L =  Low[CurrentCandle];
          i = CCIPeriod;
   if(CCI>=0) {
      CCI=LevelCCI;
      Price = -(H*i-L*i*i-H*i*i+L*i-CCI*H*K-CCI*L*K+3*SummPrice*i-
      CCI*3*K*SummPrice+CCI*H*K*i+CCI*L*K*i+CCI*3*K*SummAbs*i)/
      (i-i*i-CCI*K+CCI*K*i);
   } else {
      CCI=-LevelCCI;
      Price = -(H*i-L*i*i-H*i*i+L*i+CCI*H*K+CCI*L*K+3*SummPrice*i+
      CCI*3*K*SummPrice-CCI*H*K*i-CCI*L*K*i+CCI*3*K*SummAbs*i)/
      (i-i*i+CCI*K-CCI*K*i);
   }
   if(ObjectFind("MyLine")!=-1) ObjectDelete("MyLine");
   if(Price>H || Price<L) {
      ObjectCreate("MyLine", OBJ_HLINE, 0, 0,Price);
      ObjectSet("MyLine", OBJPROP_COLOR, Green); 
      //Price=EMPTY_VALUE;
   } else {
      ObjectCreate("MyLine", OBJ_HLINE, 0, 0,Price);
   }
   return(Price);
}//PriceCCI()